<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# osaaminen tarkastusfunktiot

function osaaminen_ok(&$msg,$id,$osaaminen,$lyhenne) {
  $table = "osaaminen";
  
  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  if ($osaaminen == '' || $lyhenne == '') {
    $msg = 'Osaaminen ja lyhenne ovat pakollisia tietoja.';
    $msg .= $tail;
    return 2;
  }

  # duplikaatit
  $dup =
    ota_yksi("SELECT id
              FROM $table
              WHERE osaaminen = '$osaaminen' OR lyhenne = '$lyhenne'
              $id_sql");
  if ($dup != '') {
    $msg = "Osaamisprofiilin nimen ja lyhenteen on oltava yksilllisi.";
    $msg .= " Tllainen osaamisprofiili on jo olemassa (id=$dup).";
    $msg .= $tail;
    return 2;
  } 

  return $ret;
}

function osaaminen_add_ok(&$msg,$osaaminen,$lyhenne) {
  return osaaminen_ok($msg,'',$osaaminen,$lyhenne);
}

function osaaminen_save_ok(&$msg,$id,$osaaminen,$lyhenne) {
  return osaaminen_ok($msg,$id,$osaaminen,$lyhenne);
}

function osaaminen_remove_ok(&$msg, $id, $log = true) {
  $table = "osaaminen";
  $ret = 0;

  if (tab_col_id("osaaminen","suojattu",$id) != 0) {
    $msg = "Tm osaamisprofiili on suojattu eik sit voi poistaa.";
    return 2;
  }

  $dup =
    ota_yksi("SELECT COUNT(*) FROM osaaminen_hlo WHERE osaaminen_id = $id");
  if ($dup > 0) {
    $msg = "Tm osaamisprofiili on kytss $dup eri henkilll eik sit"
      . " voi poistaa.";
    return 2;
  }
  
  return $ret;
}

?>

<!-- RCS $Id: osaaminen-ok.php,v 1.1 2009/06/19 15:03:58 riku Exp $ -->
