<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

$file = basename(__FILE__);

include "common.php";

# synchronize two ViHa - instances with each other.

# as we have to have two database connections open at the same time
# (possibly to same machine, different databases), our normal helper
# functions are not up to task. hence some replacements.

# -----------------------------------------------------------------------------
# generic functions
# -----------------------------------------------------------------------------

function s_mysql_query ($sql, $link, $database) {
  $ret = mysql_select_db($database, $link);
  if (! $ret)
    die("<p>mysql_select_db: " . mysql_error($link) . "\n");
  $ret = mysql_query($sql, $link);
  if (! $ret) {
    $herja = mysql_error($link);
    die("<p>Invalid query sql=$sql: $herja");
  }
  return $ret;
}

function s_yksi ($sql, $link, $db) {
  $ret = 0;
  $result = s_mysql_query ($sql,$link,$db);
  if ($result) {
    $data = mysql_fetch_row($result);
    $ret = $data[0];
  }
  return $ret;
}

# set the timestamp to be the same as the latter of the two.
# no change if the timestamps are the same. return correct ts.

function sync_ts($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$l_ts,$r_id,$r_ts) {
  if ($l_ts > $r_ts) {
    echo "local timestamp later, setting ";
    s_mysql_query("UPDATE $tab SET ts = '$l_ts' WHERE id = $r_id",
		  $r_link, $r_db);
    return $l_ts;
  }
  if ($r_ts > $l_ts) {
    echo "remote timestamp later, setting ";
    s_mysql_query("UPDATE $tab SET ts = '$r_ts' WHERE id = $l_id",
		  $l_link, $l_db);
    return $r_ts;
  }
  echo "timestamps equal ";
  return $l_ts;
}

# sync two records on different databases according to ts.
# we do nothing iff the contents are exactly equal.

function sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$l_ts,$r_id,$r_ts,
		     $a,$b)
{
  $update_tab = "update_$tab";

  if ($a == $b) {
    echo "contents equal ";
    return $l_ts;
  }
  
  if ($r_ts >= $l_ts) {
    echo "remote ts later or equal, remote -> local ";
    $update_tab($l_link,$l_db,$l_id,$b);
    return $r_ts;
  }
  
  if ($l_ts > $r_ts) {
    echo "local ts later, local -> remote ";
    $update_tab($r_link,$r_db,$l_id,$a);
    return $l_ts;
  }
}

# resolve a situation where the same data exists but under different ids
# locally and remotely. assign new fresh id suitable for both sides
# and reassign both old ids to new one as needed. return fresh id.
# l_ = local, r_ = remote
# link = database link, db = database name, tab = table, id = id in table,
# do = do in this instance

function new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$r_id,$l_do,$r_do) {
  $sql1 = "SELECT MAX(id)+1 FROM $tab";
  $new_r = s_yksi($sql1, $r_link, $r_db);
  $new_l = s_yksi($sql1, $l_link, $l_db);
  $new_id = max($new_r,$new_l);
  echo "old ids=$l_id,$r_id new candidates=$new_l,$new_r chosen=$new_id ";
  $tab_new_id = $tab . "_new_id";
  if ($l_do)
    $tab_new_id($l_link,$l_db,$l_id,$new_id);
  if ($r_do)
    $tab_new_id($r_link,$r_db,$r_id,$new_id);
  return $new_id;
} # new id

# generic sync logic. uses external functions to resolve the table-dependent
# stuff. this can be used w/ tables where id and ts do exist.
# l_ = local, r_ = remote, _link = database link, _db = database name,
# tab = table

function sync_tab($l_link, $l_db, $r_link, $r_db, $tab) {
  $insert_tab = "insert_$tab";
  $sql_select_same_tab = "sql_select_same_$tab";
  $is_same_tab = "is_same_$tab";
  $is_protected_tab_id = "is_protected_$tab" . "_id";
  $sql1 = "SELECT * FROM $tab ORDER BY id";
  $l = s_mysql_query($sql1, $l_link, $l_db);
  while ($a = mysql_fetch_array($l)) {
    $l_id = $a['id'];
    $l_ts = $a['ts'];
    $sql_select_same = $sql_select_same_tab($tab, $a); #
    echo "<p>id=$l_id, ";
    if ($is_protected_tab_id($l_id)) {
      # do NOT sync anything protected
      echo "id protected.";
      continue;
    }
    $sql2 = "SELECT * FROM $tab WHERE id = $l_id";
    $r = s_mysql_query($sql2, $r_link, $r_db);
    $b = mysql_fetch_array($r);
    $r_id = $b['id'];
    $r_ts = $b['ts'];
    if ($r_id == $l_id) {
      # id does exist on remote
      echo "id does exist remotely, ";
      if ($is_same_tab($tab,$a,$b)) { # 
	# id does exist on remote, data is the same. later ts wins.
	echo "data equal, ";
	sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$l_ts,$r_id,$r_ts,
		    $a,$b);
      } else { # contents differ
        # id does exist on remote, contents are not the same.
	# check if it does exist remotely under some other id.
	echo "data differs, ";
	$sql3 = $sql_select_same;
	$o_r_id = s_yksi($sql3, $r_link, $r_db);
	if ($o_r_id != '') {
	  # does exist remotely under other id.
	  # assign new id on both and update. check timestamps.
	  echo
	    "exists remotely as $o_r_id. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	  sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts,
		      $a,$b);
	} else {
	  # does not exist remotely, but id taken.
	  # assign new id locally and create it on remote.
	  echo "does not exist remotely, id taken. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,false);
	  $insert_tab($r_link, $r_db, $n_id, $a);
	}
      } # contents differ
    } else { # l_id != r_id (r_id == '')
      # id does not exist on remote.
      # check if it exists remotely under some other id.
      echo "id does not exist remotely, ";
      $sql5 = $sql_select_same;
      $o_r_id = s_yksi($sql5, $r_link, $r_db);
      if ($o_r_id != '') {
	# does exist remotely under other id.
	# assign new id on both and update.
	echo
	  "exists remotely as $o_r_id. fixing. ";
	$n_id =
	  new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts,
		    $a,$b);
      } else {
	# does not exist remotely at all. id free. create.
	echo "does not exist remotely at all, id free. creating. ";
	$insert_tab($r_link, $r_db, $l_id, $a);
      }
    } # l_id != r_id
  } # while local
} # sync_tab

# -----------------------------------------------------------------------------
# functions relating to different tables
# -----------------------------------------------------------------------------

function sync_versio($l_link, $l_db, $r_link, $r_db) {
  $tab = "versio";
  $sql1 = "SELECT * FROM $tab ORDER BY id";
  $l = s_mysql_query($sql1, $l_link, $l_db);
  while ($a = mysql_fetch_array($l)) {
    $l_id = $a['id'];
    $l_versio = $a['versio'];
    echo "<p>id=$l_id, ";
    $sql2 = "SELECT * FROM $tab WHERE id = $l_id";
    $r = s_mysql_query($sql2, $r_link, $r_db);
    $b = mysql_fetch_array($r);
    $r_id = $b['id'];
    $r_versio = $b['versio'];
    if ($r_id != $l_id) {
      # id does not exist on remote
      die("<p>sync_versio: id $l_id does not exist remotely. stop.");
    }
    echo "id does exist remotely, ";
    if ($r_versio != $l_versio) {
      # data differs
      die("<p>sync_versio: id $l_id, data differs, $l_versio != $r_versio ."
	  . " stop.");
    }
    echo "data equal. ok! ";
  }
}

# -----------------------------------------------------------------------------

function sync_juuei($l_link, $l_db, $r_link, $r_db) {
  $tab = "juuei";
  $sql1 = "SELECT * FROM $tab ORDER BY id";
  $l = s_mysql_query($sql1, $l_link, $l_db);
  while ($a = mysql_fetch_array($l)) {
    $l_id = $a['id'];
    $l_juuei = $a['juuei'];
    echo "<p>id=$l_id, ";
    $sql2 = "SELECT * FROM $tab WHERE id = $l_id";
    $r = s_mysql_query($sql2, $r_link, $r_db);
    $b = mysql_fetch_array($r);
    $r_id = $b['id'];
    $r_juuei = $b['juuei'];
    if ($r_id != $l_id) {
      # id does not exist on remote
      die("<p>sync_juuei: id $l_id does not exist remotely. stop.");
    }
    echo "id does exist remotely, ";
    if ($r_juuei != $l_juuei) {
      # data differs
      die("<p>sync_juuei: id $l_id, data differs, $l_juuei != $r_juuei ."
	  . " stop.");
    }
    echo "data equal. ok! ";
  }
}

# -----------------------------------------------------------------------------

function sync_hlo_ajat_tyyppi($l_link, $l_db, $r_link, $r_db) {
  $tab = "hlo_ajat_tyyppi";
  $sql1 = "SELECT * FROM $tab ORDER BY id";
  $l = s_mysql_query($sql1, $l_link, $l_db);
  while ($a = mysql_fetch_array($l)) {
    $l_id = $a['id'];
    $l_hlo_ajat_tyyppi = $a['hlo_ajat_tyyppi'];
    echo "<p>id=$l_id, ";
    $sql2 = "SELECT * FROM $tab WHERE id = $l_id";
    $r = s_mysql_query($sql2, $r_link, $r_db);
    $b = mysql_fetch_array($r);
    $r_id = $b['id'];
    $r_hlo_ajat_tyyppi = $b['hlo_ajat_tyyppi'];
    if ($r_id != $l_id) {
      # id does not exist on remote
      die("<p>sync_hlo_ajat_tyyppi: id $l_id does not exist remotely. stop.");
    }
    echo "id does exist remotely, ";
    if ($r_hlo_ajat_tyyppi != $l_hlo_ajat_tyyppi) {
      # data differs
      die("<p>sync_hlo_ajat_tyyppi: id $l_id,"
	  . " data differs, $l_hlo_ajat_tyyppi != $r_hlo_ajat_tyyppi ."
	  . " stop.");
    }
    echo "data equal. ok! ";
  }
}

# -----------------------------------------------------------------------------

# table contains temporary data. just remove contents.

function sync_suoja($l_link, $l_db, $r_link, $r_db) {
  $tab = "suoja";
  $sql1 = "DELETE FROM $tab";
  s_mysql_query($sql1, $l_link, $l_db);
  echo "<p>local cleared. ";
}

# -----------------------------------------------------------------------------

# assign new id to area. change all deps as well.

function alue_new_id($link,$db,$old_id,$new_id) {
  global $prefix;

  $tab = "alue";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  s_mysql_query("UPDATE hlo_ajat
                 SET variable_id = $new_id
                 WHERE variable_id = $old_id AND hlo_ajat_tyyppi_id = 3",
		$link,$db);
  $std_tabs = array("hlo", "hlo_tila", "jarjesto", "kadonnut", "kayttajat_alue",
		    "laite", "loki", "loytynyt", "osaaminen", "paikka",
		    "paivystys", "ryhma", "ryhma_tila", "tap", "tavara");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  } # foreach
  # session needs fixing in some cases
  if (s("alue") == $old_id)
    $_SESSION[$prefix . 'alue'] = $new_id;
} # alue new id

function is_protected_alue_id($id) {
  if ($id < 4)
    return true;
  
  return false;
}

function sync_alue($l_link, $l_db, $r_link, $r_db) {
  $tab = "alue";
  $sql1 = "SELECT * FROM $tab ORDER BY id";
  $l = s_mysql_query($sql1, $l_link, $l_db);
  while ($a = mysql_fetch_array($l)) {
    $l_id = $a['id'];
    $l_alue = $a['alue'];
    $l_ts = $a['ts'];
    $sql_select_same = "SELECT id FROM $tab WHERE alue = '$l_alue'";
    echo "<p>id=$l_id, ";
    if (is_protected_alue_id($l_id)) {
      # do NOT sync anything protected
      echo " id protected.";
      continue;
    }
    $sql2 = "SELECT * FROM $tab WHERE id = $l_id";
    $r = s_mysql_query($sql2, $r_link, $r_db);
    $b = mysql_fetch_array($r);
    $r_id = $b['id'];
    $r_alue = $b['alue'];
    $r_ts = $b['ts'];
    if ($r_id == $l_id) {
      # id does exist on remote
      echo "id does exist remotely, ";
      if ($r_alue == $l_alue) {
	# id does exist on remote, contents are the same. just fix ts if needed.
	echo "contents same, ";
	sync_ts($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$l_ts,$r_id,$r_ts);
      } else { # contents differ
	# id does exist on remote, contents are not the same.
	# check if it does exist remotely under some other id.
	echo "contents differ, ";
	$sql3 = $sql_select_same;
	$o_r_id = s_yksi($sql3, $r_link, $r_db);
	if ($o_r_id != '') {
	  # does exist remotely under other id.
	  # assign new id on both and update. check timestamps.
	  echo
	    "does exist remotely under other id. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	  sync_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts);
	} else {
	  # does not exist remotely, but id taken.
	  # assign new id locally and create it on remote. check timestamps.
	  echo "does not exist remotely, id taken. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,false);
	  $sql6 =
	    "INSERT INTO $tab SET id = $n_id, alue = '$l_alue', ts = '$l_ts'";
	  s_mysql_query($sql6, $r_link, $r_db);
	}
      } # contents differ
    } else { # l_id != r_id (r_id == '')
      # id does not exist on remote.
      # check if it exists remotely under some other id.
      echo "id does not exist remotely, ";
      $sql5 = $sql_select_same;
      $o_r_id = s_yksi($sql5, $r_link, $r_db);
      if ($o_r_id != '') {
	# does exist remotely under other id.
	# assign new id on both and update.
	echo
	  "exists remotely as $o_r_id. fixing. ";
	$n_id =
	  new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	sync_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts);
      } else {
	# does not exist remotely at all. id free. create.
	echo "does not exist remotely at all, id free. creating. ";
	$sql4 =
	  "INSERT INTO $tab SET id = $l_id, alue = '$l_alue', ts = '$l_ts'";
	s_mysql_query($sql4, $r_link, $r_db);
      }
    } # l_id != r_id
  } # while local
} # sync_alue

# -----------------------------------------------------------------------------

# assign new id to person. change all deps as well.

function hlo_new_id($link,$db,$old_id,$new_id) {
  $tab = "hlo";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  $std_tabs = array("hlo_ajat", "kayttajat", "laite", "osaaminen_hlo",
		    "tavara");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  } # foreach
} # hlo new id

function update_hlo($link,$db,$id,$a) {
  $sql =
    "UPDATE hlo
     SET alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         nimi='$a[nimi]',
         puhelin='$a[puhelin]',
         ryhma_id=$a[ryhma_id],
         hlo_tila_id=$a[hlo_tila_id],
         hlo_asema_id=$a[hlo_asema_id],
         jarjesto_id=$a[jarjesto_id],
         halyssa = $a[halyssa],
         ra='$a[ra]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_hlo($link,$db,$id,$a) {
  $sql =
    "INSERT INTO hlo
     SET id = $id,
         alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         nimi='$a[nimi]',
         puhelin='$a[puhelin]',
         ryhma_id=$a[ryhma_id],
         hlo_tila_id=$a[hlo_tila_id],
         hlo_asema_id=$a[hlo_asema_id],
         jarjesto_id=$a[jarjesto_id],
         halyssa = $a[halyssa],
         ra='$a[ra]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function is_protected_hlo_id($id) {
  return false;
}

function sync_hlo($l_link, $l_db, $r_link, $r_db) {
  $tab = "hlo";
  $insert_tab = "insert_$tab";
  $sql1 = "SELECT * FROM $tab ORDER BY id";
  $l = s_mysql_query($sql1, $l_link, $l_db);
  while ($a = mysql_fetch_array($l)) {
    $l_id = $a['id'];
    $l_nimi = $a['nimi'];
    $l_ts = $a['ts'];
    $sql_select_same = "SELECT id FROM $tab WHERE nimi = '$l_nimi'";
    echo "<p>id=$l_id, ";
    if (is_protected_hlo_id($l_id)) {
      # do NOT sync anything protected
      echo " id protected.";
      continue;
    }
    $sql2 = "SELECT * FROM $tab WHERE id = $l_id";
    $r = s_mysql_query($sql2, $r_link, $r_db);
    $b = mysql_fetch_array($r);
    $r_id = $b['id'];
    $r_nimi = $b['nimi'];
    $r_ts = $b['ts'];
    if ($r_id == $l_id) {
      # id does exist on remote
      echo "id does exist remotely, ";
      if ($r_nimi == $l_nimi) {
	# id does exist on remote, names are the same. later ts wins.
	echo "names equal, ";
	sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$l_ts,$r_id,$r_ts,
		    $a,$b);
      } else { # contents differ
        # id does exist on remote, contents are not the same.
	# check if it does exist remotely under some other id.
	echo "contents differ, ";
	$sql3 = $sql_select_same;
	$o_r_id = s_yksi($sql3, $r_link, $r_db);
	if ($o_r_id != '') {
	  # does exist remotely under other id.
	  # assign new id on both and update. check timestamps.
	  echo
	    "exists remotely as $o_r_id. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	  sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts,
		      $a,$b);
	} else {
	  # does not exist remotely, but id taken.
	  # assign new id locally and create it on remote.
	  echo "does not exist remotely, id taken. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,false);
	  $insert_tab($r_link, $r_db, $n_id, $a);
	}
      } # contents differ
    } else { # l_id != r_id (r_id == '')
      # id does not exist on remote.
      # check if it exists remotely under some other id.
      echo "id does not exist remotely, ";
      $sql5 = $sql_select_same;
      $o_r_id = s_yksi($sql5, $r_link, $r_db);
      if ($o_r_id != '') {
	# does exist remotely under other id.
	# assign new id on both and update.
	echo
	  "exists remotely as $o_r_id. fixing. ";
	$n_id =
	  new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts,
		    $a,$b);
      } else {
	# does not exist remotely at all. id free. create.
	echo "does not exist remotely at all, id free. creating. ";
	$insert_tab($r_link, $r_db, $l_id, $a);
      }
    } # l_id != r_id
  } # while local
} # sync_hlo

# -----------------------------------------------------------------------------

# assign new id to person-time. change all deps as well.

function hlo_ajat_new_id($link,$db,$old_id,$new_id) {
  $tab = "hlo_ajat";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
} # hlo_ajat new id

function update_hlo_ajat($link,$db,$id,$a) {
  $sql =
    "UPDATE hlo_ajat
     SET hlo_id = $a[hlo_id],
         hlo_ajat_tyyppi_id = $a[hlo_ajat_tyyppi_id],
         variable_id=$a[variable_id],
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_hlo_ajat($link,$db,$id,$a) {
  $sql =
    "INSERT INTO hlo_ajat
     SET id = $id,
         hlo_id = $a[hlo_id],
         hlo_ajat_tyyppi_id = $a[hlo_ajat_tyyppi_id],
         variable_id=$a[variable_id],
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function is_protected_hlo_ajat_id($id) {
  return false;
}

function sync_hlo_ajat($l_link, $l_db, $r_link, $r_db) {
  $tab = "hlo_ajat";
  $insert_tab = "insert_$tab";
  $sql1 = "SELECT * FROM $tab ORDER BY id";
  $l = s_mysql_query($sql1, $l_link, $l_db);
  while ($a = mysql_fetch_array($l)) {
    $l_id = $a['id'];
    $l_hlo_id = $a['hlo_id'];
    $l_hlo_ajat_tyyppi_id = $a['hlo_ajat_tyyppi_id'];
    $l_variable_id = $a['variable_id'];
    $l_ts = $a['ts'];
    $sql_select_same =
      "SELECT id
       FROM $tab
       WHERE hlo_id = $l_hlo_id
             AND hlo_ajat_tyyppi_id = $l_hlo_ajat_tyyppi_id
             AND variable_id = $l_variable_id
             AND ts = '$l_ts'";
    echo "<p>id=$l_id, ";
    if (is_protected_hlo_ajat_id($l_id)) {
      # do NOT sync anything protected
      echo " id protected.";
      continue;
    }
    $sql2 = "SELECT * FROM $tab WHERE id = $l_id";
    $r = s_mysql_query($sql2, $r_link, $r_db);
    $b = mysql_fetch_array($r);
    $r_id = $b['id'];
    $r_hlo_id = $b['hlo_id'];
    $r_hlo_ajat_tyyppi_id = $b['hlo_ajat_tyyppi_id'];
    $r_variable_id = $b['variable_id'];
    $r_ts = $b['ts'];
    if ($r_id == $l_id) {
      # id does exist on remote
      echo "id does exist remotely, ";
      if ($r_hlo_id == $l_hlo_id
	  && $r_hlo_ajat_tyyppi_id == $l_hlo_ajat_tyyppi_id
	  && $r_variable_id == $l_variable_id
	  && $r_ts == $l_ts) {
	# id does exist on remote, data is the same. later ts wins.
	echo "data equal, ";
	sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$l_ts,$r_id,$r_ts,
		    $a,$b);
      } else { # contents differ
        # id does exist on remote, contents are not the same.
	# check if it does exist remotely under some other id.
	echo "data differs, ";
	$sql3 = $sql_select_same;
	$o_r_id = s_yksi($sql3, $r_link, $r_db);
	if ($o_r_id != '') {
	  # does exist remotely under other id.
	  # assign new id on both and update. check timestamps.
	  echo
	    "exists remotely as $o_r_id. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	  sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts,
		      $a,$b);
	} else {
	  # does not exist remotely, but id taken.
	  # assign new id locally and create it on remote.
	  echo "does not exist remotely, id taken. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,false);
	  $insert_tab($r_link, $r_db, $n_id, $a);
	}
      } # contents differ
    } else { # l_id != r_id (r_id == '')
      # id does not exist on remote.
      # check if it exists remotely under some other id.
      echo "id does not exist remotely, ";
      $sql5 = $sql_select_same;
      $o_r_id = s_yksi($sql5, $r_link, $r_db);
      if ($o_r_id != '') {
	# does exist remotely under other id.
	# assign new id on both and update.
	echo
	  "exists remotely as $o_r_id. fixing. ";
	$n_id =
	  new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts,
		    $a,$b);
      } else {
	# does not exist remotely at all. id free. create.
	echo "does not exist remotely at all, id free. creating. ";
	$insert_tab($r_link, $r_db, $l_id, $a);
      }
    } # l_id != r_id
  } # while local
} # sync_hlo_ajat

# -----------------------------------------------------------------------------

# assign new id to person rank. change all deps as well.

function hlo_asema_new_id($link,$db,$old_id,$new_id) {
  $tab = "hlo_asema";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  s_mysql_query("UPDATE hlo_ajat
                 SET variable_id = $new_id
                 WHERE variable_id = $old_id AND hlo_ajat_tyyppi_id = 6",
		$link,$db);
  $std_tabs = array("hlo");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
} # hlo_asema new id

function update_hlo_asema($link,$db,$id,$a) {
  $sql =
    "UPDATE hlo_asema
     SET hlo_asema = '$a[hlo_asema]',
         suojattu=$a[suojattu],
         pri=$a[pri],
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_hlo_asema($link,$db,$id,$a) {
  $sql =
    "INSERT INTO hlo_asema
     SET id = $id,
         hlo_asema = '$a[hlo_asema]',
         suojattu=$a[suojattu],
         pri=$a[pri],
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function is_protected_hlo_asema_id($id) {
  if ($id < 10)
    return true;
  
  return false;
}

function sync_hlo_asema($l_link, $l_db, $r_link, $r_db) {
  $tab = "hlo_asema";
  $insert_tab = "insert_$tab";
  $sql1 = "SELECT * FROM $tab ORDER BY id";
  $l = s_mysql_query($sql1, $l_link, $l_db);
  while ($a = mysql_fetch_array($l)) {
    $l_id = $a['id'];
    $l_hlo_asema = $a['hlo_asema'];
    $l_ts = $a['ts'];
    $sql_select_same =
      "SELECT id
       FROM $tab
       WHERE hlo_asema = '$l_hlo_asema'";
    echo "<p>id=$l_id, ";
    if (is_protected_hlo_asema_id($l_id)) {
      # do NOT sync anything protected
      echo " id protected.";
      continue;
    }
    $sql2 = "SELECT * FROM $tab WHERE id = $l_id";
    $r = s_mysql_query($sql2, $r_link, $r_db);
    $b = mysql_fetch_array($r);
    $r_id = $b['id'];
    $r_hlo_asema = $b['hlo_asema'];
    $r_ts = $b['ts'];
    if ($r_id == $l_id) {
      # id does exist on remote
      echo "id does exist remotely, ";
      if ($r_hlo_asema == $l_hlo_asema) {
	# id does exist on remote, data is the same. later ts wins.
	echo "data equal, ";
	sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$l_ts,$r_id,$r_ts,
		    $a,$b);
      } else { # contents differ
        # id does exist on remote, contents are not the same.
	# check if it does exist remotely under some other id.
	echo "data differs, ";
	$sql3 = $sql_select_same;
	$o_r_id = s_yksi($sql3, $r_link, $r_db);
	if ($o_r_id != '') {
	  # does exist remotely under other id.
	  # assign new id on both and update. check timestamps.
	  echo
	    "exists remotely as $o_r_id. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	  sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts,
		      $a,$b);
	} else {
	  # does not exist remotely, but id taken.
	  # assign new id locally and create it on remote.
	  echo "does not exist remotely, id taken. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,false);
	  $insert_tab($r_link, $r_db, $n_id, $a);
	}
      } # contents differ
    } else { # l_id != r_id (r_id == '')
      # id does not exist on remote.
      # check if it exists remotely under some other id.
      echo "id does not exist remotely, ";
      $sql5 = $sql_select_same;
      $o_r_id = s_yksi($sql5, $r_link, $r_db);
      if ($o_r_id != '') {
	# does exist remotely under other id.
	# assign new id on both and update.
	echo
	  "exists remotely as $o_r_id. fixing. ";
	$n_id =
	  new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts,
		    $a,$b);
      } else {
	# does not exist remotely at all. id free. create.
	echo "does not exist remotely at all, id free. creating. ";
	$insert_tab($r_link, $r_db, $l_id, $a);
      }
    } # l_id != r_id
  } # while local
} # sync_hlo_asema

# -----------------------------------------------------------------------------

# assign new id to person status. change all deps as well.

function hlo_tila_new_id($link,$db,$old_id,$new_id) {
  $tab = "hlo_tila";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  $std_tabs = array("hlo");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
} # hlo_tila new id

function update_hlo_tila($link,$db,$id,$a) {
  $sql =
    "UPDATE hlo_tila
     SET alue_id=$a[alue_id],
         paivystys_id=$a[paivystys_id],
         hlo_tila='$a[hlo_tila]',
         paikalla = $a[paikalla],
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_hlo_tila($link,$db,$id,$a) {
  $sql =
    "INSERT INTO hlo_tila
     SET id = $id,
         alue_id=$a[alue_id],
         paivystys_id=$a[paivystys_id],
         hlo_tila='$a[hlo_tila]',
         paikalla = $a[paikalla],
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function is_protected_hlo_tila_id($id) {
  if ($id < 6)
    return true;
  
  return false;
}

function sync_hlo_tila($l_link, $l_db, $r_link, $r_db) {
  $tab = "hlo_tila";
  $insert_tab = "insert_$tab";
  $sql1 = "SELECT * FROM $tab ORDER BY id";
  $l = s_mysql_query($sql1, $l_link, $l_db);
  while ($a = mysql_fetch_array($l)) {
    $l_id = $a['id'];
    $l_alue_id = $a['alue_id'];
    $l_paivystys_id = $a['paivystys_id'];
    $l_hlo_tila = $a['hlo_tila'];
    $l_ts = $a['ts'];
    $sql_select_same =
      "SELECT id
       FROM $tab
       WHERE alue_id = $l_alue_id
             AND paivystys_id = $l_paivystys_id
             AND hlo_tila = '$l_hlo_tila'";
    echo "<p>id=$l_id, ";
    if (is_protected_hlo_tila_id($l_id)) {
      # do NOT sync anything protected
      echo " id protected.";
      continue;
    }
    $sql2 = "SELECT * FROM $tab WHERE id = $l_id";
    $r = s_mysql_query($sql2, $r_link, $r_db);
    $b = mysql_fetch_array($r);
    $r_id = $b['id'];
    $r_alue_id = $b['alue_id'];
    $r_paivystys_id = $b['paivystys_id'];
    $r_hlo_tila = $b['hlo_tila'];
    $r_ts = $b['ts'];
    if ($r_id == $l_id) {
      # id does exist on remote
      echo "id does exist remotely, ";
      if ($r_hlo_tila == $l_hlo_tila
	  && $r_alue_id == $l_alue_id
	  && $r_paivystys_id == $l_paivystys_id) {
        # id does exist on remote, data is the same. later ts wins.
	echo "data equal, ";
	sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$l_ts,$r_id,$r_ts,
		    $a,$b);
      } else { # contents differ
        # id does exist on remote, contents are not the same.
	# check if it does exist remotely under some other id.
	echo "data differs, ";
	$sql3 = $sql_select_same;
	$o_r_id = s_yksi($sql3, $r_link, $r_db);
	if ($o_r_id != '') {
	  # does exist remotely under other id.
	  # assign new id on both and update. check timestamps.
	  echo
	    "exists remotely as $o_r_id. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	  sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts,
		      $a,$b);
	} else {
	  # does not exist remotely, but id taken.
	  # assign new id locally and create it on remote.
	  echo "does not exist remotely, id taken. fixing. ";
	  $n_id =
	    new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,false);
	  $insert_tab($r_link, $r_db, $n_id, $a);
	}
      } # contents differ
    } else { # l_id != r_id (r_id == '')
      # id does not exist on remote.
      # check if it exists remotely under some other id.
      echo "id does not exist remotely, ";
      $sql5 = $sql_select_same;
      $o_r_id = s_yksi($sql5, $r_link, $r_db);
      if ($o_r_id != '') {
	# does exist remotely under other id.
	# assign new id on both and update.
	echo
	  "exists remotely as $o_r_id. fixing. ";
	$n_id =
	  new_id($l_link,$l_db,$r_link,$r_db,$tab,$l_id,$o_r_id,true,true);
	sync_tab_ts($l_link,$l_db,$r_link,$r_db,$tab,$n_id,$l_ts,$n_id,$r_ts,
		    $a,$b);
      } else {
	# does not exist remotely at all. id free. create.
	echo "does not exist remotely at all, id free. creating. ";
	$insert_tab($r_link, $r_db, $l_id, $a);
      }
    } # l_id != r_id
  } # while local
} # sync_hlo_tila

# -----------------------------------------------------------------------------

# assign new id to organisation. change all deps as well.

function jarjesto_new_id($link,$db,$old_id,$new_id) {
  $tab = "jarjesto";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  $std_tabs = array("hlo", "laite", "tavara");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
} # jarjesto new id

function update_jarjesto($link,$db,$id,$a) {
  $sql =
    "UPDATE jarjesto
     SET jarjesto='$a[jarjesto]',
         alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_jarjesto($link,$db,$id,$a) {
  $sql =
    "INSERT INTO jarjesto
     SET id = $id,
         jarjesto='$a[jarjesto]',
         alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_jarjesto($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE alue_id = $a[alue_id]
           AND jarjesto = '$a[jarjesto]'";
  return $sql;
}

function is_same_jarjesto($tab,$a,$b) {
  if ($a['alue_id'] == $b['alue_id']
      && $a['jarjesto'] == $b['jarjesto'])
    return true;

  return false;
}

function is_protected_jarjesto_id($id) {
  if ($id < 3)
    return true;
  
  return false;
}

# -----------------------------------------------------------------------------

# assign new id to missing person. change all deps as well.

function kadonnut_new_id($link,$db,$old_id,$new_id) {
  $tab = "kadonnut";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
} # kadonnut new id

function update_kadonnut($link,$db,$id,$a) {
  $sql =
    "UPDATE kadonnut
     SET alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         lapsi_tila_id = $a[lapsi_tila_id],
         mmm = '$a[mmm]',
         kello = '$a[kello]',
         nimi = '$a[nimi]',
         lempinimi = '$a[lempinimi]',
         ika = '$a[ika]',
         pituus = '$a[pituus]',
         paino = '$a[paino]',
         sairaudet = '$a[sairaudet]',
         sukupuoli = '$a[sukupuoli]',
         housut = '$a[housut]',
         paita = '$a[paita]',
         kengat = '$a[kengat]',
         hame = '$a[hame]',
         puku = '$a[puku]',
         paahine = '$a[paahine]',
         hiusten_vari = '$a[hiusten_vari]',
         hiusten_pituus = '$a[hiusten_pituus]',
         tuntomerkit = '$a[tuntomerkit]',
         varustus = '$a[varustus]',
         liikkuminen = '$a[liikkuminen]',
         muuta_huomioitavaa = '$a[muuta_huomioitavaa]',
         viimeksi_kello = '$a[viimeksi_kello]',
         viimeksi_paikka = '$a[viimeksi_paikka]',
         blues_tarra = '$a[blues_tarra]',
         blues_nimi = '$a[blues_nimi]',
         blues_puhelin = '$a[blues_puhelin]',
         muuta1 = '$a[muuta1]',
         omainen_nimi = '$a[omainen_nimi]',
         omainen_puhelin = '$a[omainen_puhelin]',
         omainen_sijainti = '$a[omainen_sijainti]',
         omainen_osoite = '$a[omainen_osoite]',
         ilmoittaja_nimi = '$a[ilmoittaja_nimi]',
         ilmoittaja_puhelin = '$a[ilmoittaja_puhelin]',
         ilmoittaja_sijainti = '$a[ilmoittaja_sijainti]',
         ilmoittaja_asema = '$a[ilmoittaja_asema]',
         kuulutuspyynto1 = '$a[kuulutuspyynto1]',
         kuulutuspyynto2 = '$a[kuulutuspyynto2]',
         kuulutuspyynto3 = '$a[kuulutuspyynto3]',
         kuulutuspyynto4 = '$a[kuulutuspyynto4]',
         kuulutus1 = '$a[kuulutus1]',
         kuulutus2 = '$a[kuulutus2]',
         kuulutus3 = '$a[kuulutus3]',
         kuulutus4 = '$a[kuulutus4]',
         loydetty_kello = '$a[loydetty_kello]',
         loydetty_mista = '$a[loydetty_mista]',
         loydetty_odottaa = '$a[loydetty_odottaa]',
         poliisi_kello = '$a[poliisi_kello]',
         poliisi_vastaanotti = '$a[poliisi_vastaanotti]',
         muuta2 = '$a[muuta2]',
         muuta3 = '$a[muuta3]',
         loytaneet_kello = '$a[loytaneet_kello]',
         loytaneet_missa = '$a[loytaneet_missa]',
         halytyksen_vastaanotti = '$a[halytyksen_vastaanotti]',
         ts = '$a[ts]'
     WHERE id = $id";
  s_mysql_query($sql,$link,$db);
}

function insert_kadonnut($link,$db,$id,$a) {
  $sql =
    "INSERT INTO kadonnut
     SET id = $id,
         alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         lapsi_tila_id = $a[lapsi_tila_id],
         mmm = '$a[mmm]',
         kello = '$a[kello]',
         nimi = '$a[nimi]',
         lempinimi = '$a[lempinimi]',
         ika = '$a[ika]',
         pituus = '$a[pituus]',
         paino = '$a[paino]',
         sairaudet = '$a[sairaudet]',
         sukupuoli = '$a[sukupuoli]',
         housut = '$a[housut]',
         paita = '$a[paita]',
         kengat = '$a[kengat]',
         hame = '$a[hame]',
         puku = '$a[puku]',
         paahine = '$a[paahine]',
         hiusten_vari = '$a[hiusten_vari]',
         hiusten_pituus = '$a[hiusten_pituus]',
         tuntomerkit = '$a[tuntomerkit]',
         varustus = '$a[varustus]',
         liikkuminen = '$a[liikkuminen]',
         muuta_huomioitavaa = '$a[muuta_huomioitavaa]',
         viimeksi_kello = '$a[viimeksi_kello]',
         viimeksi_paikka = '$a[viimeksi_paikka]',
         blues_tarra = '$a[blues_tarra]',
         blues_nimi = '$a[blues_nimi]',
         blues_puhelin = '$a[blues_puhelin]',
         muuta1 = '$a[muuta1]',
         omainen_nimi = '$a[omainen_nimi]',
         omainen_puhelin = '$a[omainen_puhelin]',
         omainen_sijainti = '$a[omainen_sijainti]',
         omainen_osoite = '$a[omainen_osoite]',
         ilmoittaja_nimi = '$a[ilmoittaja_nimi]',
         ilmoittaja_puhelin = '$a[ilmoittaja_puhelin]',
         ilmoittaja_sijainti = '$a[ilmoittaja_sijainti]',
         ilmoittaja_asema = '$a[ilmoittaja_asema]',
         kuulutuspyynto1 = '$a[kuulutuspyynto1]',
         kuulutuspyynto2 = '$a[kuulutuspyynto2]',
         kuulutuspyynto3 = '$a[kuulutuspyynto3]',
         kuulutuspyynto4 = '$a[kuulutuspyynto4]',
         kuulutus1 = '$a[kuulutus1]',
         kuulutus2 = '$a[kuulutus2]',
         kuulutus3 = '$a[kuulutus3]',
         kuulutus4 = '$a[kuulutus4]',
         loydetty_kello = '$a[loydetty_kello]',
         loydetty_mista = '$a[loydetty_mista]',
         loydetty_odottaa = '$a[loydetty_odottaa]',
         poliisi_kello = '$a[poliisi_kello]',
         poliisi_vastaanotti = '$a[poliisi_vastaanotti]',
         muuta2 = '$a[muuta2]',
         muuta3 = '$a[muuta3]',
         loytaneet_kello = '$a[loytaneet_kello]',
         loytaneet_missa = '$a[loytaneet_missa]',
         halytyksen_vastaanotti = '$a[halytyksen_vastaanotti]',
         ts = '$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_kadonnut($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE nimi = '$a[nimi]'
           AND kello = '$a[kello]'";
  return $sql;
}

function is_same_kadonnut($tab,$a,$b) {
  if ($a['nimi'] == $b['nimi']
      && $a['kello'] == $b['kello'])
    return true;

  return false;
}

function is_protected_kadonnut_id($id) {
  return false;
}

# -----------------------------------------------------------------------------

# kayttajat is not synced.

# -----------------------------------------------------------------------------

# radio equipment.

function laite_new_id($link,$db,$old_id,$new_id) {
  $tab = "laite";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
} # laite new id

function update_laite($link,$db,$id,$a) {
  $sql =
    "UPDATE laite
     SET alue_id = $a[alue_id],
         paivystys_id=$a[paivystys_id],
         jarjesto_id=$a[jarjesto_id],
         hlo_id=$a[hlo_id],
         laite='$a[laite]',
         tunniste='$a[tunniste]',
         selite='$a[selite]',
         verkko_id=$a[verkko_id],
         ryhma_id=$a[ryhma_id],
         merkitty=$a[merkitty],
         vakuutettu=$a[vakuutettu],
         vara_akut=$a[vara_akut],
         laite_tyyppi_id=$a[laite_tyyppi_id],
         palaute='$a[palaute]',
         lisavarusteet='$a[lisavarusteet]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_laite($link,$db,$id,$a) {
  $sql =
    "INSERT INTO laite
     SET id = $id,
         alue_id = $a[alue_id],
         paivystys_id=$a[paivystys_id],
         jarjesto_id=$a[jarjesto_id],
         hlo_id=$a[hlo_id],
         laite='$a[laite]',
         tunniste='$a[tunniste]',
         selite='$a[selite]',
         verkko_id=$a[verkko_id],
         ryhma_id=$a[ryhma_id],
         merkitty=$a[merkitty],
         vakuutettu=$a[vakuutettu],
         vara_akut=$a[vara_akut],
         laite_tyyppi_id=$a[laite_tyyppi_id],
         palaute='$a[palaute]',
         lisavarusteet='$a[lisavarusteet]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_laite($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE jarjesto_id = $a[jarjesto_id]
           AND laite = '$a[laite]'
           AND tunniste = '$a[tunniste]'";
  return $sql;
}

function is_same_laite($tab,$a,$b) {
  if ($a['jarjesto_id'] == $b['jarjesto_id']
      && $a['laite'] == $b['laite']
      && $a['tunniste'] == $b['tunniste'])
    return true;

  return false;
}

function is_protected_laite_id($id) {
  return false;
}

# -----------------------------------------------------------------------------

# radio equipment type.

function laite_tyyppi_new_id($link,$db,$old_id,$new_id) {
  $tab = "laite_tyyppi";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  $std_tabs = array("laite");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
} # laite_tyyppi new id

function update_laite_tyyppi($link,$db,$id,$a) {
  $sql =
    "UPDATE laite_tyyppi
     SET laite_tyyppi = '$a[laite_tyyppi]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_laite_tyyppi($link,$db,$id,$a) {
  $sql =
    "INSERT INTO laite_tyyppi
     SET id = $id,
         laite_tyyppi = '$a[laite_tyyppi]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_laite_tyyppi($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE laite_tyyppi = '$a[laite_tyyppi]'";
  return $sql;
}

function is_same_laite_tyyppi($tab,$a,$b) {
  if ($a['laite_tyyppi'] == $b['laite_tyyppi'])
    return true;

  return false;
}

function is_protected_laite_tyyppi_id($id) {
  if ($id < 2)
    return true;
  
  return false;
}

# -----------------------------------------------------------------------------

# assign new id to missing/found type. change all deps as well.

function lapsi_tila_new_id($link,$db,$old_id,$new_id) {
  $tab = "lapsi_tila";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  $std_tabs = array("kadonnut", "loytynyt");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
} # lapsi_tila new id

function update_lapsi_tila($link,$db,$id,$a) {
  $sql =
    "UPDATE lapsi_tila
     SET pri = $a[pri],
         lapsi_tila = '$a[lapsi_tila]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_lapsi_tila($link,$db,$id,$a) {
  $sql =
    "INSERT INTO lapsi_tila
     SET id = $id,
         pri = $a[pri],
         lapsi_tila = '$a[lapsi_tila]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_lapsi_tila($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE lapsi_tila = '$a[lapsi_tila]'";
  return $sql;
}

function is_same_lapsi_tila($tab,$a,$b) {
  if ($a['lapsi_tila'] == $b['lapsi_tila'])
    return true;

  return false;
}

function is_protected_lapsi_tila_id($id) {
  if ($id < 5)
    return true;
  
  return false;
}

# -----------------------------------------------------------------------------

# log entry.

function loki_new_id($link,$db,$old_id,$new_id) {
  $tab = "loki";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
} # loki new id

function update_loki($link,$db,$id,$a) {
  $data = str_replace("'", "\'", $a['data']);
  $sql =
    "UPDATE loki
     SET alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         data='$data',
         ip='$a[ip]',
         user='$a[user]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_loki($link,$db,$id,$a) {
  $data = str_replace("'", "\'", $a['data']);
  $sql =
    "INSERT INTO loki
     SET id = $id,
         alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         data='$data',
         ip='$a[ip]',
         user='$a[user]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_loki($tab, $a) {
  $data = str_replace("'", "\'", $a['data']);
  $sql = 
    "SELECT id
     FROM $tab
     WHERE alue_id = $a[alue_id]
           AND paivystys_id = $a[paivystys_id]
           AND data = '$data'
           AND ip = '$a[ip]'
           AND user = '$a[user]'
           AND ts = '$a[ts]'";
  return $sql;
}

function is_same_loki($tab,$a,$b) {
  if ($a['alue_id'] == $b['alue_id']
      && $a['paivystys_id'] == $b['paivystys_id']
      && $a['data'] == $b['data']
      && $a['ip'] == $b['ip']
      && $a['user'] == $b['user']
      && $a['ts'] == $b['ts'])
    return true;

  return false;
}

function is_protected_loki_id($id) {
  return false;
}

# -----------------------------------------------------------------------------

# found person.

function loytynyt_new_id($link,$db,$old_id,$new_id) {
  $tab = "loytynyt";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
} # loytynyt new id

function update_loytynyt($link,$db,$id,$a) {
  $sql =
    "UPDATE loytynyt
     SET alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         lapsi_tila_id = $a[lapsi_tila_id],
         kello = '$a[kello]',
         nimi = '$a[nimi]',
         ika = '$a[ika]',
         pituus = '$a[pituus]',
         paino = '$a[paino]', 
         sukupuoli = '$a[sukupuoli]',
         housut = '$a[housut]',
         paita = '$a[paita]',
         kengat = '$a[kengat]',
         paahine = '$a[paahine]',
         hiusten_vari = '$a[hiusten_vari]',
         hiusten_pituus = '$a[hiusten_pituus]',
         tuntomerkit = '$a[tuntomerkit]', 
         mista_loytyi = '$a[mista_loytyi]',
         blues_tarra = '$a[blues_tarra]',
         blues_nimi = '$a[blues_nimi]',
         blues_puhelin = '$a[blues_puhelin]',
         muuta1 = '$a[muuta1]', 
         omainen_nimi = '$a[omainen_nimi]',
         omainen_puhelin = '$a[omainen_puhelin]',
         omainen_sijainti = '$a[omainen_sijainti]',
         omainen_osoite = '$a[omainen_osoite]', 
         ilmoittaja_nimi = '$a[ilmoittaja_nimi]',
         ilmoittaja_puhelin = '$a[ilmoittaja_puhelin]',
         ilmoittaja_sijainti = '$a[ilmoittaja_sijainti]', 
         soitettu_omaiselle_kello = '$a[soitettu_omaiselle_kello]',
         soitettu_omaiselle_numeroon = '$a[soitettu_omaiselle_numeroon]',
         soitettu_omaiselle_tulos = '$a[soitettu_omaiselle_tulos]',
         kuulutuspyynto1 = '$a[kuulutuspyynto1]',
         kuulutuspyynto2 = '$a[kuulutuspyynto2]',
         kuulutuspyynto3 = '$a[kuulutuspyynto3]',
         kuulutuspyynto4 = '$a[kuulutuspyynto4]', 
         kuulutus1 = '$a[kuulutus1]',
         kuulutus2 = '$a[kuulutus2]',
         kuulutus3 = '$a[kuulutus3]',
         kuulutus4 = '$a[kuulutus4]', 
         loydetty_kello = '$a[loydetty_kello]',
         loydetty_mista = '$a[loydetty_mista]',
         loydetty_odottaa = '$a[loydetty_odottaa]', 
         poliisi_kello = '$a[poliisi_kello]',
         poliisi_vastaanotti = '$a[poliisi_vastaanotti]', 
         muuta2 = '$a[muuta2]', 
         loytaneet_kello = '$a[loytaneet_kello]',
         loytaneet_missa = '$a[loytaneet_missa]', 
         ts = '$a[ts]'
     WHERE id = $id";
  s_mysql_query($sql,$link,$db);
}

function insert_loytynyt($link,$db,$id,$a) {
  $sql =
    "INSERT INTO loytynyt
     SET id = $id,
         alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         lapsi_tila_id = $a[lapsi_tila_id],
         kello = '$a[kello]',
         nimi = '$a[nimi]',
         ika = '$a[ika]',
         pituus = '$a[pituus]',
         paino = '$a[paino]', 
         sukupuoli = '$a[sukupuoli]',
         housut = '$a[housut]',
         paita = '$a[paita]',
         kengat = '$a[kengat]',
         paahine = '$a[paahine]',
         hiusten_vari = '$a[hiusten_vari]',
         hiusten_pituus = '$a[hiusten_pituus]',
         tuntomerkit = '$a[tuntomerkit]', 
         mista_loytyi = '$a[mista_loytyi]',
         blues_tarra = '$a[blues_tarra]',
         blues_nimi = '$a[blues_nimi]',
         blues_puhelin = '$a[blues_puhelin]',
         muuta1 = '$a[muuta1]', 
         omainen_nimi = '$a[omainen_nimi]',
         omainen_puhelin = '$a[omainen_puhelin]',
         omainen_sijainti = '$a[omainen_sijainti]',
         omainen_osoite = '$a[omainen_osoite]', 
         ilmoittaja_nimi = '$a[ilmoittaja_nimi]',
         ilmoittaja_puhelin = '$a[ilmoittaja_puhelin]',
         ilmoittaja_sijainti = '$a[ilmoittaja_sijainti]', 
         soitettu_omaiselle_kello = '$a[soitettu_omaiselle_kello]',
         soitettu_omaiselle_numeroon = '$a[soitettu_omaiselle_numeroon]',
         soitettu_omaiselle_tulos = '$a[soitettu_omaiselle_tulos]',
         kuulutuspyynto1 = '$a[kuulutuspyynto1]',
         kuulutuspyynto2 = '$a[kuulutuspyynto2]',
         kuulutuspyynto3 = '$a[kuulutuspyynto3]',
         kuulutuspyynto4 = '$a[kuulutuspyynto4]', 
         kuulutus1 = '$a[kuulutus1]',
         kuulutus2 = '$a[kuulutus2]',
         kuulutus3 = '$a[kuulutus3]',
         kuulutus4 = '$a[kuulutus4]', 
         loydetty_kello = '$a[loydetty_kello]',
         loydetty_mista = '$a[loydetty_mista]',
         loydetty_odottaa = '$a[loydetty_odottaa]', 
         poliisi_kello = '$a[poliisi_kello]',
         poliisi_vastaanotti = '$a[poliisi_vastaanotti]', 
         muuta2 = '$a[muuta2]', 
         loytaneet_kello = '$a[loytaneet_kello]',
         loytaneet_missa = '$a[loytaneet_missa]', 
         ts = '$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_loytynyt($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE nimi = '$a[nimi]'
           AND kello = '$a[kello]'";
  return $sql;
}

function is_same_loytynyt($tab,$a,$b) {
  if ($a['nimi'] == $b['nimi']
      && $a['kello'] == $b['kello'])
    return true;

  return false;
}

function is_protected_loytynyt_id($id) {
  return false;
}

# -----------------------------------------------------------------------------

# competence.

function osaaminen_new_id($link,$db,$old_id,$new_id) {
  $tab = "osaaminen";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  $std_tabs = array("osaaminen_hlo");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
} # osaaminen new id

function update_osaaminen($link,$db,$id,$a) {
  $sql =
    "UPDATE osaaminen
     SET alue_id=$a[alue_id],
         paivystys_id=$a[paivystys_id],
         suojattu = $a[suojattu],
         osaaminen='$a[osaaminen]',
         lyhenne='$a[lyhenne]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_osaaminen($link,$db,$id,$a) {
  $sql =
    "INSERT INTO osaaminen
     SET id = $id,
         alue_id=$a[alue_id],
         paivystys_id=$a[paivystys_id],
         suojattu = $a[suojattu],
         osaaminen='$a[osaaminen]',
         lyhenne='$a[lyhenne]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_osaaminen($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE alue_id = $a[alue_id]
           AND paivystys_id = $a[paivystys_id]
           AND osaaminen = '$a[osaaminen]'";
  return $sql;
}

function is_same_osaaminen($tab,$a,$b) {
  if ($a['alue_id'] == $b['alue_id']
      && $a['paivystys_id'] == $b['paivystys_id']
      && $a['osaaminen'] == $b['osaaminen'])
    return true;

  return false;
}

function is_protected_osaaminen_id($id) {
  if ($id < 19)
    return true;
  
  return false;
}

# -----------------------------------------------------------------------------

# location.

function paikka_new_id($link,$db,$old_id,$new_id) {
  $tab = "paikka";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  $std_tabs = array("ryhma");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
} # paikka new id

function update_paikka($link,$db,$id,$a) {
  $sql =
    "UPDATE paikka
     SET alue_id=$a[alue_id],
         paivystys_id=$a[paivystys_id],
         paikka='$a[paikka]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_paikka($link,$db,$id,$a) {
  $sql =
    "INSERT INTO paikka
     SET id = $id,
         alue_id=$a[alue_id],
         paivystys_id=$a[paivystys_id],
         paikka='$a[paikka]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_paikka($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE alue_id = $a[alue_id]
           AND paivystys_id = $a[paivystys_id]
           AND paikka = '$a[paikka]'";
  return $sql;
}

function is_same_paikka($tab,$a,$b) {
  if ($a['alue_id'] == $b['alue_id']
      && $a['paivystys_id'] == $b['paivystys_id']
      && $a['paikka'] == $b['paikka'])
    return true;

  return false;
}

function is_protected_paikka_id($id) {
  if ($id < 5)
    return true;
  
  return false;
}

# -----------------------------------------------------------------------------

# operation.

function paivystys_new_id($link,$db,$old_id,$new_id) {
  $tab = "paivystys";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  s_mysql_query("UPDATE hlo_ajat
                 SET variable_id = $new_id
                 WHERE variable_id = $old_id
                       AND (hlo_ajat_tyyppi_id = 1
                            OR hlo_ajat_tyyppi_id = 2
                            OR hlo_ajat_tyyppi_id = 4)",
		$link,$db);
  $std_tabs = array("hlo", "hlo_tila", "jarjesto", "kadonnut",
		    "kayttajat_paivystys", "laite", "loki", "loytynyt",
		    "osaaminen", "paikka", "paivystys_tuki", "ryhma",
		    "ryhma_tila", "taktinen_loki", "tap", "tavara");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
} # paivystys new id

function update_paivystys($link,$db,$id,$a) {
  $sql =
    "UPDATE paivystys
     SET alue_id=$a[alue_id],
         nimi='$a[nimi]',
         oletus_verkko_id=$a[oletus_verkko_id],
         johto_ryhma_id=$a[johto_ryhma_id],
         viesti_ryhma_id=$a[viesti_ryhma_id],
         alkoi='$a[alkoi]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_paivystys($link,$db,$id,$a) {
  $sql =
    "INSERT INTO paivystys
     SET id = $id,
         alue_id=$a[alue_id],
         nimi='$a[nimi]',
         oletus_verkko_id=$a[oletus_verkko_id],
         johto_ryhma_id=$a[johto_ryhma_id],
         viesti_ryhma_id=$a[viesti_ryhma_id],
         alkoi='$a[alkoi]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_paivystys($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE alue_id = $a[alue_id]
           AND nimi = '$a[nimi]'
           AND alkoi = '$a[alkoi]'";
  return $sql;
}

# operation is deemed to be equal if area, name and creation *date* match.
# 1234567890
# 2009-12-06 12:34:56

function is_same_paivystys($tab,$a,$b) {
  if ($a['alue_id'] == $b['alue_id']
      && $a['nimi'] == $b['nimi']
      && substr($a['alkoi'],0,10) == substr($b['alkoi'],0,10))
    return true;

  return false;
}

function is_protected_paivystys_id($id) {
  if ($id < 3)
    return true;
  
  return false;
}

# -----------------------------------------------------------------------------

# squad.

function ryhma_new_id($link,$db,$old_id,$new_id) {
  $tab = "ryhma";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  s_mysql_query("UPDATE hlo_ajat
                 SET variable_id = $new_id
                 WHERE variable_id = $old_id
                       AND hlo_ajat_tyyppi_id = 5",
		$link,$db);
  $std_tabs = array("hlo", "laite", "paivystys_tuki", "tap", "tavara");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
  # specials
  s_mysql_query("UPDATE paivystys
                 SET johto_ryhma_id = $new_id
                 WHERE johto_ryhma_id = $old_id",
		$link,$db);
  s_mysql_query("UPDATE paivystys
                 SET viesti_ryhma_id = $new_id
                 WHERE viesti_ryhma_id = $old_id",
		$link,$db);
} # ryhma new id

function update_ryhma($link,$db,$id,$a) {
  $sql =
    "UPDATE ryhma
     SET alue_id=$a[alue_id],
         paivystys_id = $a[paivystys_id],
         paikka_id = $a[paikka_id],
         koordinaatit = '$a[koordinaatit]',
         ryhma_tila_id = $a[ryhma_tila_id],
         pri = $a[pri],
         verkko_id = $a[verkko_id],
         kutsu = '$a[kutsu]',
         puhelin = '$a[puhelin]',
         selite = '$a[selite]',
         tehtava = '$a[tehtava]',
         toiminta_alue = '$a[toiminta_alue]',
         toimintakanava = '$a[toimintakanava]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_ryhma($link,$db,$id,$a) {
  $sql =
    "INSERT INTO ryhma
     SET id = $id,
         alue_id=$a[alue_id],
         paivystys_id = $a[paivystys_id],
         paikka_id = $a[paikka_id],
         koordinaatit = '$a[koordinaatit]',
         ryhma_tila_id = $a[ryhma_tila_id],
         pri = $a[pri],
         verkko_id = $a[verkko_id],
         kutsu = '$a[kutsu]',
         puhelin = '$a[puhelin]',
         selite = '$a[selite]',
         tehtava = '$a[tehtava]',
         toiminta_alue = '$a[toiminta_alue]',
         toimintakanava = '$a[toimintakanava]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_ryhma($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE alue_id = $a[alue_id]
           AND paivystys_id = $a[paivystys_id]
           AND kutsu = '$a[kutsu]'";
  return $sql;
}

function is_same_ryhma($tab,$a,$b) {
  if ($a['alue_id'] == $b['alue_id']
      && $a['paivystys_id'] == $b['paivystys_id']
      && $a['kutsu'] == $b['kutsu'])
    return true;

  echo "$a[alue_id] == $b[alue_id]
      && $a[paivystys_id] == $b[paivystys_id]
      && $a[kutsu] == $b[kutsu] ";
  return false;
}

function is_protected_ryhma_id($id) {
  if ($id < 2)
    return true;
  
  return false;
}

# -----------------------------------------------------------------------------

# squad status.

function ryhma_tila_new_id($link,$db,$old_id,$new_id) {
  $tab = "ryhma_tila";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  $std_tabs = array("ryhma");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
} # ryhma_tila new id

function update_ryhma_tila($link,$db,$id,$a) {
  $sql =
    "UPDATE ryhma_tila
     SET alue_id=$a[alue_id],
         paivystys_id = $a[paivystys_id],
         ryhma_tila = '$a[ryhma_tila]',
         suojattu = $a[suojattu],
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_ryhma_tila($link,$db,$id,$a) {
  $sql =
    "INSERT INTO ryhma_tila
     SET id = $id,
         alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         ryhma_tila = '$a[ryhma_tila]',
         suojattu = $a[suojattu],
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_ryhma_tila($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE alue_id = $a[alue_id]
           AND paivystys_id = $a[paivystys_id]
           AND ryhma_tila = '$a[ryhma_tila]'";
  return $sql;
}

function is_same_ryhma_tila($tab,$a,$b) {
  if ($a['alue_id'] == $b['alue_id']
      && $a['paivystys_id'] == $b['paivystys_id']
      && $a['ryhma_tila'] == $b['ryhma_tila'])
    return true;

  return false;
}

function is_protected_ryhma_tila_id($id) {
  if ($id < 14)
    return true;
  
  return false;
}

# -----------------------------------------------------------------------------

# tactical log.

function taktinen_loki_new_id($link,$db,$old_id,$new_id) {
  $tab = "taktinen_loki";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
} # taktinen_loki new id

function update_taktinen_loki($link,$db,$id,$a) {
  $sql =
    "UPDATE taktinen_loki
     SET paivystys_id = $a[paivystys_id],
         data = '$a[data]',
         ip = '$a[ip]',
         user = '$a[user]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_taktinen_loki($link,$db,$id,$a) {
  $sql =
    "INSERT INTO taktinen_loki
     SET id = $id,
         paivystys_id = $a[paivystys_id],
         data = '$a[data]',
         ip = '$a[ip]',
         user = '$a[user]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_taktinen_loki($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE paivystys_id = $a[paivystys_id]
           AND data = '$a[data]'
           AND ip = '$a[ip]'
           AND user = '$a[user]'
           AND ts = '$a[ts]'";
  return $sql;
}

function is_same_taktinen_loki($tab,$a,$b) {
  if ($a['paivystys_id'] == $b['paivystys_id']
      && $a['data'] == $b['data']
      && $a['ip'] == $b['ip']
      && $a['user'] == $b['user']
      && $a['ts'] == $b['ts'])
    return true;

  return false;
}

function is_protected_taktinen_loki_id($id) {
  return false;
}

# -----------------------------------------------------------------------------

# events.

function tap_new_id($link,$db,$old_id,$new_id) {
  $tab = "tap";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
} # tap new id

function update_tap($link,$db,$id,$a) {
  $sql =
    "UPDATE tap
     SET alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         ryhma_id = $a[ryhma_id],
         tap = '$a[tap]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_tap($link,$db,$id,$a) {
  $sql =
    "INSERT INTO tap
     SET id = $id,
         alue_id = $a[alue_id],
         paivystys_id = $a[paivystys_id],
         ryhma_id = $a[ryhma_id],
         tap = '$a[tap]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_tap($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE alue_id = $a[alue_id]
           AND paivystys_id = $a[paivystys_id]
           AND ryhma_id = $a[ryhma_id]
           AND tap = '$a[tap]'
           AND ts = '$a[ts]'";
  return $sql;
}

function is_same_tap($tab,$a,$b) {
  if ($a['alue_id'] == $b['alue_id']
      && $a['paivystys_id'] == $b['paivystys_id']
      && $a['ryhma_id'] == $b['ryhma_id']
      && $a['tap'] == $b['tap']
      && $a['ts'] == $b['ts'])
    return true;

  return false;
}

function is_protected_tap_id($id) {
  return false;
}

# -----------------------------------------------------------------------------

# other equipment.

function tavara_new_id($link,$db,$old_id,$new_id) {
  $tab = "tavara";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
} # tavara new id

function update_tavara($link,$db,$id,$a) {
  $sql =
    "UPDATE tavara
     SET alue_id = $a[alue_id],
         paivystys_id=$a[paivystys_id],
         jarjesto_id=$a[jarjesto_id],
         hlo_id=$a[hlo_id],
         tavara='$a[tavara]',
         tunniste='$a[tunniste]',
         selite = '$a[selite]',
         palaute = '$a[palaute]',
         ryhma_id = $a[ryhma_id],
         merkitty = $a[merkitty],
         vakuutettu = $a[vakuutettu],
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_tavara($link,$db,$id,$a) {
  $sql =
    "INSERT INTO tavara
     SET id = $id,
         alue_id = $a[alue_id],
         paivystys_id=$a[paivystys_id],
         jarjesto_id=$a[jarjesto_id],
         hlo_id=$a[hlo_id],
         tavara='$a[tavara]',
         tunniste='$a[tunniste]',
         selite='$a[selite]',
         palaute = '$a[palaute]',
         ryhma_id = $a[ryhma_id],
         merkitty = $a[merkitty],
         vakuutettu = $a[vakuutettu],
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_tavara($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE jarjesto_id = $a[jarjesto_id]
           AND tavara = '$a[tavara]'
           AND tunniste = '$a[tunniste]'";
  return $sql;
}

function is_same_tavara($tab,$a,$b) {
  if ($a['jarjesto_id'] == $b['jarjesto_id']
      && $a['tavara'] == $b['tavara']
      && $a['tunniste'] == $b['tunniste'])
    return true;

  return false;
}

function is_protected_tavara_id($id) {
  return false;
}

# -----------------------------------------------------------------------------

# other equipment type.

function tavara_tyyppi_new_id($link,$db,$old_id,$new_id) {
  $tab = "tavara_tyyppi";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  $std_tabs = array("tavara");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
} # tavara_tyyppi new id

function update_tavara_tyyppi($link,$db,$id,$a) {
  $sql =
    "UPDATE tavara_tyyppi
     SET tavara_tyyppi = '$a[tavara_tyyppi]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_tavara_tyyppi($link,$db,$id,$a) {
  $sql =
    "INSERT INTO tavara_tyyppi
     SET id = $id,
         tavara_tyyppi = '$a[tavara_tyyppi]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_tavara_tyyppi($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE tavara_tyyppi = '$a[tavara_tyyppi]'";
  return $sql;
}

function is_same_tavara_tyyppi($tab,$a,$b) {
  if ($a['tavara_tyyppi'] == $b['tavara_tyyppi'])
    return true;

  return false;
}

function is_protected_tavara_tyyppi_id($id) {
  if ($id < 10)
    return true;
  
  return false;
}

# -----------------------------------------------------------------------------

# radio network.

function verkko_new_id($link,$db,$old_id,$new_id) {
  $tab = "verkko";
  $tab_id = $tab . "_id";
  s_mysql_query("UPDATE $tab SET id = $new_id WHERE id = $old_id",
		$link,$db);
  $std_tabs = array("laite", "ryhma");
  foreach ($std_tabs as $std_tab) {
    s_mysql_query("UPDATE $std_tab
                   SET $tab_id = $new_id
                   WHERE $tab_id = $old_id",
		  $link,$db);
  }
  # specials
  s_mysql_query("UPDATE paivystys
                 SET oletus_verkko_id = $new_id
                 WHERE oletus_verkko_id = $old_id",
		$link,$db);
} # verkko new id

function update_verkko($link,$db,$id,$a) {
  $sql =
    "UPDATE verkko
     SET verkko = '$a[verkko]',
         selite = '$a[selite]',
         ts='$a[ts]'
     WHERE id=$id";
  s_mysql_query($sql,$link,$db);
}

function insert_verkko($link,$db,$id,$a) {
  $sql =
    "INSERT INTO verkko
     SET id = $id,
         verkko = '$a[verkko]',
         selite = '$a[selite]',
         ts='$a[ts]'";
  s_mysql_query($sql,$link,$db);
}

function sql_select_same_verkko($tab, $a) {
  $sql = 
    "SELECT id
     FROM $tab
     WHERE verkko = '$a[verkko]'";
  return $sql;
}

function is_same_verkko($tab,$a,$b) {
  if ($a['verkko'] == $b['verkko'])
    return true;

  return false;
}

function is_protected_verkko_id($id) {
  if ($id < 9)
    return true;
  
  return false;
}

# -----------------------------------------------------------------------------
# actual code
# -----------------------------------------------------------------------------

echo "
<html>
<head>
 <title>ViHa - Synkronointi</title>
</head>
" . body_bgcolor() . "
<h1>Tietokannan synkronointi</h1>
";

hallinnolliset_linkit();

echo "<p>Nykyinen tietokanta synkronoidaan tss annetun kanssa.";

$remoteserver = post_txt('remoteserver');
$remoteuser = post_txt('remoteuser');
$remotepass = post_pass('remotepass');
$remotedb = post_txt('remotedb');

$clear = post_txt('clear');
$run = post_txt('run');

oltava_0($file);

if ($clear != '') {
  $remoteserver = '';
  $remoteuser = '';
  $remotepass = '';
  $remotedb = '';
 }

if ($run != '') {
  echo "<p>Executing.\n";
  echo "<p>Local database $config_mysql_user@$config_mysql_server:$config_db open.\n";

  $rlink =
    mysql_connect($remoteserver,$remoteuser,$remotepass,true);
  if (! $rlink) {
    die("<p>mysql_connect failed.\n");
  }
  $ret = mysql_select_db($remotedb, $rlink);
  if (! $ret) {
    die("<p>mysql_select_db: " . mysql_errno($rlink) . ": "
	. mysql_error($rlink). "\n");
  }
  echo "<p>Remote database $remoteuser@$remoteserver:$remotedb open.\n";

  $l_db = $config_db;
  $l_link = $link;
  $r_db = $remotedb;
  $r_link = $rlink;
  
  # old-fashioned sync logic, many of these can be converted to
  # new type
  $tabs = array("versio", "juuei", "hlo_ajat_tyyppi", "suoja", "alue", "hlo",
		"hlo_ajat", "hlo_asema", "hlo_tila");
  foreach ($tabs as $tab) {
    $sync_tab = "sync_$tab";
    echo "<p>$tab, normal roles";
    $sync_tab($l_link, $l_db, $r_link, $r_db);
    echo "<p>$tab, reversed roles";
    $sync_tab($r_link, $r_db, $l_link, $l_db);
  }

  # new type of sync logic. 
  $tabs = array("jarjesto", "kadonnut",	"laite", "laite_tyyppi", "lapsi_tila",
		"loki", "loytynyt", "osaaminen", "paikka", "paivystys",
		"ryhma", "ryhma_tila", "taktinen_loki",	"tap", "tavara",
		"tavara_tyyppi", "verkko");
  foreach ($tabs as $tab) {
    echo "<p>$tab, normal roles";
    sync_tab($l_link, $l_db, $r_link, $r_db, $tab);
    echo "<p>$tab, reversed roles";
    sync_tab($r_link, $r_db, $l_link, $l_db, $tab);
  }

  $now = date('Y-m-d H:i:s');
  $hostname = $_SERVER['SERVER_NAME'];
  $ip = $_SERVER['SERVER_ADDR'];
  $sql = "INSERT INTO synced
          SET hostname = '$hostname',
              ip = '$ip',
              ts = '$now'";
  s_mysql_query($sql, $r_link, $r_db);
  
  echo "<p>All done!";

 } else { # ! run
  print "<form action=\"\" method=\"POST\">\n";
  print "<p><table border=0>\n";

  print "<tr><td>Palvelin:";
  if ($readonly) {
    print "<td>$remoteserver\n";
  } else {
    print "<td><input type=\"text\" name=\"remoteserver\" size=64 maxlength=64";
    print " value=\"$remoteserver\">\n";
  }

  print "<tr><td>Kyttjtunnus:";
  if ($readonly) {
    print "<td>$remoteuser\n";
  } else {
    print "<td><input type=\"text\" name=\"remoteuser\" size=32 maxlength=32";
    print " value=\"$remoteuser\">\n";
  }

  print "<tr><td>Salasana:";
  if ($readonly) {
    print "<td>$remotepass\n";
  } else {
    print "<td><input type=\"password\" name=\"remotepass\" size=32 maxlength=32";
    print " value=\"$remotepass\">\n";
  }

  print "<tr><td>Tietokanta:";
  if ($readonly) {
    print "<td>$remotedb\n";
  } else {
    print "<td><input type=\"text\" name=\"remotedb\" size=32 maxlength=32";
    print " value=\"$remotedb\">\n";
  }

  print "</table>\n";

  echo "<input type=\"submit\" name=\"run\" value=\"SUORITA\">\n";
  echo "<input type=\"submit\" name=\"clear\" value=\"TYHJENN\">\n";

  print "</form>\n";
 } # !run

loppu();

?>
</body> 
</html>
<!-- RCS $Id: sync.php,v 1.38 2009/10/04 12:10:28 riku Exp $ -->
